%% 11. CREACIN DE MATRIZ DE CONFUSIN ANFIS GLOBAL

    trnOpt(3)=0.01; %initial step size  
    trnOpt(4)=0.9; %step size decrease rate
    trnOpt(5)=1.1; %step size increase rate   
    dispOpt(1)=1;
    dispOpt(2)=1;
    dispOpt(3)=1;
    dispOpt(4)=1;
    optMethod=1;
    resultado_anfis_global=[];
    fila=1;
    
    trnOpt(1)=10  %% training epoch number - parametro a elegir
    trnOpt(2)=0.001 %% Error de entrenamiento
    r=0.56
            
    R=[r r r r]

    initFis = genfis2(datos_entrenamiento_global,targets_entrenamiento_global,r);
    [FIS,ERROR,STEPSIZE,CHKFIS,CHKERROR] =  anfis(datostargets_entrenamiento_global,initFis,trnOpt,dispOpt,datostargets_test_global,optMethod)

    output=evalfis(datos_test_global',FIS)

    matriz_confusion_anfis_global=zeros(22,22)

    for caso=1:22 %Para seleccin de datos de outputs
        for i=1:800 %Para seleccin de datos de outputs
            m=23
            for target_comparacion=1:22
            k=(output((caso-1)*800+i,1))-target_comparacion
            caso_output((caso-1)*800+i,1)=output((caso-1)*800+i,1); %para comparar...
                if(abs(k)<abs(m))
                m=k
                caso_obtenido=target_comparacion
                end
            end
            matriz_confusion_anfis_global(caso,caso_obtenido)=matriz_confusion_anfis_global(caso,caso_obtenido)+(100/800)
        end
    end           
%% 12. CREACIN DE MATRIZ DE CONFUSIN RBF GLOBAL

    goal = 0.001; %Mean squared error goal
    DF = 25; %Number of neurons to add between displays, default = 25.
    spread=3 
    MN=460
    net= newrb(datos_entrenamiento_global',targets_entrenamiento_global',goal,spread,MN,DF)

    output=net(datos_test_global')
    output=output'

    matriz_confusion_rbf_global=zeros(22,22)
    

    for caso=1:22 %Para seleccin de datos de outputs
        for i=1:800 %Para seleccin de datos de outputs
            m=23
            for target_comparacion=1:22
            k=(output((caso-1)*800+i,1))-target_comparacion
            caso_output((caso-1)*800+i,1)=output((caso-1)*800+i,1); %para comparar...
                if(abs(k)<abs(m))
                m=k
                caso_obtenido=target_comparacion
                end
            end
            matriz_confusion_rbf_global(caso,caso_obtenido)=matriz_confusion_rbf_global(caso,caso_obtenido)+(100/800)
        end
    end        

%% 13. CREACIN DE MATRIZ DE CONFUSIN BP GLOBAL

    a=370 %iteraciones de entrenamiento
    n=5
    net= newff(minmax(datos_entrenamiento_global'),[n,1],{'purelin','purelin','trainlm'});
    net.trainParam.epochs=a;
    [net,tr] = train(net,datos_entrenamiento_global', targets_entrenamiento_global');
    output=net(datos_test_global')
    output=output'
    matriz_confusion_bp_global=zeros(22,22)

    for caso=1:22 %Para seleccin de datos de outputs
        for i=1:800 %Para seleccin de datos de outputs
            m=23
            for target_comparacion=1:22
            k=(output((caso-1)*800+i,1))-target_comparacion
            caso_output((caso-1)*800+i,1)=output((caso-1)*800+i,1); %para comparar...
                if(abs(k)<abs(m))
                m=k
                caso_obtenido=target_comparacion
                end
            end
            matriz_confusion_bp_global(caso,caso_obtenido)=matriz_confusion_bp_global(caso,caso_obtenido)+(100/800)
        end
    end
    
%% 14. CREACIN DE MATRIZ DE CONFUSIN ANFIS INDIVIDUAL
 
    trnOpt(3)=0.01; %initial step size  
    trnOpt(4)=0.9; %step size decrease rate
    trnOpt(5)=1.1; %step size increase rate   
    dispOpt(1)=1;
    dispOpt(2)=1;
    dispOpt(3)=1;
    dispOpt(4)=1;
    optMethod=1;
    trnOpt(2)=0.001; 
            
    trnOpt(1)=10; %% training epoch number   
    
    matriz_confusion_anfis_individual=zeros(22,4)
    casos=[1 2 3 4 5 7 8 9 10 11 12 13 14 15 16 17 19 20 21 22]
    for caso=casos
        datos_caso(1:1280,:)=datos_individual((caso-1)*1280+1:1280*caso,1:v)
        datos_entrenamiento_individual=datos_caso(1:480,:)
        targets_entrenamiento_individual=caso*ones(480,1); 
        if caso==1;
            r=0.29    
        end
        if caso==2;
            r=0.47    
        end
        if caso==3;
            r=0.52    
        end
        if caso==4;
            r=0.48    
        end
        if caso==5;
            r=0.4    
        end
        if caso==7;
            r=0.38    
        end
        if caso==8;
            r=0.72    
        end
        if caso==9;
            r=0.69   
        end
        if caso==10;
            r=0.46    
        end
        if caso==11;
            r=0.53    
        end
        if caso==12;
            r=0.47    
        end
        if caso==13;
            r=0.56    
        end
        if caso==14;
            r=0.49   
        end
        if caso==15;
            r=0.48    
        end
        if caso==16;
            r=0.43    
        end
        if caso==17;
            r=0.51    
        end
        if caso==19;
            r=0.45    
        end
        if caso==20;
            r=0.51   
        end
        if caso==21;
            r=0.48   
        end
        if caso==22;
            r=0.38    
        end

        R=[r r r r];
      
        entrada=[datos_entrenamiento_individual targets_entrenamiento_individual];
        for n=casos %Para seleccin de datos de outputs
            datos_caso(1:1280,:)=datos_individual((n-1)*1280+1:1280*n,1:v)
            datos_test_individual=datos_caso(481:end,:)    
            targets_test_individual=n*ones(800,1);          
            salida=[datos_test_individual targets_test_individual]
            initFis = genfis2(datos_entrenamiento_individual,targets_entrenamiento_individual,r);
            [FIS,ERROR,STEPSIZE,CHKFIS,CHKERROR] =  anfis(entrada,initFis,trnOpt,dispOpt,salida,optMethod)     
            matriz_confusion_anfis_individual(caso,n)=mse(CHKERROR)
        end            

end   
    
%% 15. CREACIN DE MATRIZ DE CONFUSIN RBF INDIVIDUAL
 
    goal = 0.001; %Mean squared error goal
    DF = 25; %Number of neurons to add between displays, default = 25.
    MN=10 %%Es vlido para todos

    matriz_confusion_rbf_individual=zeros(22,22)
    for caso=1:22
        datos_caso(1:1280,:)=datos_individual((caso-1)*1280+1:1280*caso,1:v)
        datos_entrenamiento_individual=datos_caso(1:480,:)
        datos_test_individual_1=datos_caso(481:end,:)
        targets_entrenamiento_individual=caso*ones(480,1);
        targets_test_individual=caso*ones(800,1);

        if caso==1
            spread=1   
        end
        if caso==2
            spread=3   
        end
        if caso==3
            spread=4   
        end
        if caso==4
            spread=4   
        end
        if caso==5
            spread=1   
        end
        if caso==6
            spread=1   
        end
        if caso==7
            spread=1   
        end
        if caso==8
            spread=4   
        end
        if caso==9
            spread=3   
        end
        if caso==10
            spread=1   
        end
        if caso==11
            spread=4   
        end
        if caso==12
            spread=2   
        end
        if caso==13
            spread=1   
        end
        if caso==14
            spread=1   
        end
        if caso==15
            spread=1   
        end
        if caso==16
            spread=4   
        end
        if caso==17
            spread=4   
        end
        if caso==18
            spread=1   
        end
        if caso==19
            spread=4   
        end
        if caso==20
            spread=1   
        end
        if caso==21
            spread=1   
        end
        if caso==22
            spread=3   
        end
        net= newrb(datos_entrenamiento_individual',targets_entrenamiento_individual',goal,spread,MN,DF)
        for n=1:22 %Para seleccin de datos de outputs              
            datos_caso(1:1280,:)=datos_individual((n-1)*1280+1:1280*n,1:v)       
            datos_test_individual=datos_caso(481:end,:)          
            matriz_confusion_rbf_individual(caso,n)=mse(sim(net,datos_test_individual)-n)
        end        
    end       
%% 16. CREACIN DE MATRIZ DE CONFUSIN BP INDIVIDUAL
    matriz_confusion_bp_individual=zeros(22,4)
    for caso=1:22
        datos_caso(1:1280,:)=datos_individual((caso-1)*1280+1:1280*caso,1:v)
        datos_entrenamiento_individual=datos_caso(1:480,:)
        targets_entrenamiento_individual=caso*ones(480,1);
        if caso==1
            neuronas=15  
            a=1640
        end
        if caso==2
            neuronas=25  
            a=4570
        end
        if caso==3
            neuronas=55 
            a=4090
        end
        if caso==4
            neuronas=15
            a=790
        end
        if caso==5
            neuronas=5 
            a=250
        end
        if caso==6
            neuronas=5
            a=4780
        end
        if caso==7
            neuronas=5   
            a=150
        end
        if caso==8
            neuronas=5
            a=2800
        end
        if caso==9
            neuronas=5
            a=2810
        end
         if caso==10
            neuronas=5
            a=2630
         end
         if caso==11
            neuronas=5
            a=2520
         end
         if caso==12
            neuronas=5
            a=2090
         end
         if caso==13
            neuronas=5
            a=2340
         end
         if caso==14
            neuronas=5  
            a=3130
         end
         if caso==15
            neuronas=5  
            a=3770
         end
        if caso==16
            neuronas=5  
            a=1450
        end
        if caso==17
            neuronas=5  
            a=1440
        end
        if caso==18
            neuronas=5
            a=1910
        end
        if caso==19
            neuronas=5
            a=1920
        end
        if caso==20
            neuronas=5
            a=820
        end
        if caso==21
            neuronas=5
            a=2330
        end
        if caso==22
            neuronas=5
            a=1290
        end
        net= newff(minmax(datos_entrenamiento_individual'),[neuronas,1],{'purelin','purelin','trainlm'});
        net.trainParam.epochs=a
        [net,tr] = train(net,datos_entrenamiento_individual', targets_entrenamiento_individual');
    	for n=1:22 %Para seleccin de datos de outputs
            targets_test_individual=n*ones(800,1);   
            datos_caso(1:1280,:)=datos_individual((n-1)*1280+1:1280*n,1:v)
            datos_test_individual=datos_caso(481:end,:)
            matriz_confusion_bp_individual(caso,n)=mse(sim(net,datos_test_individual')-targets_test_individual')
        end        
    end    